
import java.awt.AWTException;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.methods.PostMethod;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * DisplayMeetings.java
 *
 * Created on Jul 30, 2011, 4:45:24 PM
 */
/**
 *
 * @author Flora
 */
public class DisplayMeetings extends javax.swing.JFrame {

    ArrayList<String> tableElmts; // = new ArrayList <String[]>();
    ArrayList<String> Users = new ArrayList<String>();
    ArrayList<String> Host = new ArrayList<String>();
    ArrayList<String> Presenter = new ArrayList<String>();
    String localhost;
    DefaultTableModel model;
    String username;
    //HttpClient client;
    //PostMethod method;

    DisplayMeetings() {
        initComponents();
        setResizable(false);
        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
    }

    /** Creates new form DisplayMeetings */
    public DisplayMeetings(ArrayList<String> t, String username, String loc) {
        initComponents();
        setResizable(false);
        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        tableElmts = t;
        localhost = loc;
        this.username = username;
        this.setTitle("Welcome  " + username);
        model = (DefaultTableModel) jTable1.getModel();

        for (int i = 0; i < tableElmts.size(); i++) {
            String[] fin = tableElmts.get(i).split("/");
            model.addRow(new Object[]{fin[0], fin[1], fin[2]});
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jButton2 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel2 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(175, 196, 237), 2));

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Meeting Name", "No. of People in meeting", "Meeting Host (Chairperson)"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTable1);

        jButton2.setText("Create new Meeting");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 14));
        jLabel1.setText("Select the meeting you would like to join");

        jLabel2.setFont(new java.awt.Font("Tahoma", 0, 12));
        jLabel2.setText("Or create a a new meeting...");

        jButton1.setText("Enter meeting Room");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(267, 267, 267)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 174, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(30, 30, 30)
                .addComponent(jButton2)
                .addContainerGap(227, Short.MAX_VALUE))
            .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 827, Short.MAX_VALUE)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(286, 286, 286)
                .addComponent(jButton1)
                .addContainerGap(412, Short.MAX_VALUE))
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(222, 222, 222)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 315, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(290, Short.MAX_VALUE))
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 779, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(38, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton1)
                .addGap(13, 13, 13)
                .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 9, Short.MAX_VALUE)
                .addGap(5, 5, 5)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton2)
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        jButton3.setText("Exit Application");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(15, 15, 15)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(34, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(jButton3)
                .addGap(19, 19, 19))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
        try {
            // TODO add your handling code here:
            System.out.println("ACTION");
            String state = "exit";
            HttpClient client = new HttpClient();
            client.getParams().setParameter("http.useragent", "Http Test Client");

            BufferedReader br = null;
            String url = "http://"+localhost+":8080/CSERVERLOGIN/AServer?Username="+URLEncoder.encode(username, "UTF-8");
            PostMethod method = new PostMethod(url);
            method.addParameter("State", state);
           // method.addParameter("Username", username);
            method.addParameter("selectedMeeting", "noMeetingSelected");
            System.out.println("ACTION 2");
            int returnCode = client.executeMethod(method);
            System.out.println("HTTP Status Code is --" + returnCode + "\n");
            if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
                System.err.println("The Post method is not implemented by this URI");

                // still consume the response body
                method.getResponseBodyAsString();
            } else {
                System.out.println("in else part..");
                br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
                String readLine = br.readLine();
                if (readLine.equals("EXITED")) {
                    int messageType2 = JOptionPane.INFORMATION_MESSAGE;
                    String message2 = "You have been sucessfully logged out of the application\n";
                    String title2 = "LOGOUT SUCCESSFUL";
                    JOptionPane.showMessageDialog(jPanel1, message2, title2, messageType2);
                    System.exit(0);
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(DisplayCurrentMeetingRoom.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        int s = jTable1.getSelectedRow();
        if (s == -1) {
            int messageType2 = JOptionPane.ERROR_MESSAGE;
            String message2 = "You must select a meeting from the above table\n";
            String title2 = "ERROR PROCESSING REQUEST";
            JOptionPane.showMessageDialog(jPanel1, message2, title2, messageType2);
        } else {


            try {
                String selectedMeeting = (String) jTable1.getValueAt(s, 0);
                System.out.println("meetin sent " + selectedMeeting);

                ////////////////

                HttpClient client = new HttpClient();
                client.getParams().setParameter("http.useragent", "Http Test Client");

                BufferedReader br = null;
                String url = "http://"+localhost+":8080/CSERVERLOGIN/AServer?Username="+URLEncoder.encode(username, "UTF-8")+"&selectedMeeting="+URLEncoder.encode(selectedMeeting, "UTF-8");
                PostMethod method = new PostMethod(url);
                method.addParameter("selectedMeeting", selectedMeeting);
                method.addParameter("Username", username);


                try {
                    int returnCode = client.executeMethod(method);
                    System.out.println("HTTP Status Code is --" + returnCode + "\n");
                    if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
                        System.err.println("The Post method is not implemented by this URI");

                        // still consume the response body
                        method.getResponseBodyAsString();
                    } else {//.split(" ");


                        System.out.println("in else part..");
                        System.out.println("in else part..");
                        br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
                        String readLine;
                        readLine = br.readLine();
                        if (!readLine.equals("DoesntExist")) {
                            while (((readLine = br.readLine()) != null)) {
                                System.out.println(readLine);
                                String m = readLine; //.split(" ");

                                if (m.startsWith("Host")) {
                                    Host.add(m.substring(4));
                                } else if (m.startsWith("Presenter")) {
                                    Presenter.add(m.substring(9));
                                } else {
                                    System.out.println(" ++++++   " + m);
                                    Users.add(m);
                                }

                            }

                            //String response = method.getResponseBodyAsString( );
                            // System.out.println(response);
                            System.out.println(" ++++++  3 ");
                            if (Host.contains(username)) {
                                DisplayCurrentMeetingRoom mt = new DisplayCurrentMeetingRoom(Users, username, selectedMeeting, "Host", Host, Presenter, localhost);
                                mt.setVisible(true);
                            } else {
                                DisplayCurrentMeetingRoom mt = new DisplayCurrentMeetingRoom(Users, username, selectedMeeting, "notHost", Host, Presenter, localhost);
                                 mt.setVisible(true);
                            }
                            System.out.println(" ++++++  4 ");
                            System.out.println(" ++++++  23 ");
                            dispose();
                        } else {
                            int messageType = JOptionPane.ERROR_MESSAGE;
                            String message = "The meeting you entered does not exist anymore, Please select a different meeting";
                            String title = "ERROR PROCESSING REQUEST";
                            JOptionPane.showMessageDialog(jPanel1, message, title, messageType);
                            HCLIENT xp = new HCLIENT(username, "ENTER");
                            //	 xp.setVisible(true);
                            dispose();
                        }
                    }
                } catch (Exception e) {
                    System.err.println(e);
                } finally {
                    method.releaseConnection();
                    if (br != null) {
                        try {
                            br.close();
                        } catch (Exception fe) {
                        }
                    }
                }

            } catch (UnsupportedEncodingException ex) {
                Logger.getLogger(DisplayMeetings.class.getName()).log(Level.SEVERE, null,ex);
            }

        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        try {
            // TODO add your handling code here:
            //create new meeting
            HCLIENT mdx = new HCLIENT(username);
            mdx.createMeeting();
            dispose();
        } catch (Exception ex) {
            Logger.getLogger(DisplayMeetings.class.getName()).log(Level.SEVERE, null, ex);
        } 

    }//GEN-LAST:event_jButton2ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new DisplayMeetings().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
